Index: uspace/lib/drv/include/usbhc_iface.h
===================================================================
--- uspace/lib/drv/include/usbhc_iface.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/drv/include/usbhc_iface.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -123,41 +123,4 @@
 	IPC_M_USBHC_RELEASE_ADDRESS,
 
-
-	/** Send interrupt data to device.
-	 * See explanation at usb_iface_funcs_t (OUT transaction).
-	 */
-	IPC_M_USBHC_INTERRUPT_OUT,
-
-	/** Get interrupt data from device.
-	 * See explanation at usb_iface_funcs_t (IN transaction).
-	 */
-	IPC_M_USBHC_INTERRUPT_IN,
-
-	/** Send bulk data to device.
-	 * See explanation at usb_iface_funcs_t (OUT transaction).
-	 */
-	IPC_M_USBHC_BULK_OUT,
-
-	/** Get bulk data from device.
-	 * See explanation at usb_iface_funcs_t (IN transaction).
-	 */
-	IPC_M_USBHC_BULK_IN,
-
-	/** Issue control WRITE transfer.
-	 * See explanation at usb_iface_funcs_t (OUT transaction) for
-	 * call parameters.
-	 * This call is immediately followed by two IPC data writes
-	 * from the caller (setup packet and actual data).
-	 */
-	IPC_M_USBHC_CONTROL_WRITE,
-
-	/** Issue control READ transfer.
-	 * See explanation at usb_iface_funcs_t (IN transaction) for
-	 * call parameters.
-	 * This call is immediately followed by IPC data write from the caller
-	 * (setup packet) and IPC data read (buffer that was read).
-	 */
-	IPC_M_USBHC_CONTROL_READ,
-
 	/** Register endpoint attributes at host controller.
 	 * This is used to reserve portion of USB bandwidth.
@@ -185,28 +148,23 @@
 	 * - ENOENT - unknown endpoint
 	 */
-	IPC_M_USBHC_UNREGISTER_ENDPOINT
+	IPC_M_USBHC_UNREGISTER_ENDPOINT,
+
+	/** Get data from device.
+	 * See explanation at usb_iface_funcs_t (IN transaction).
+	 */
+	IPC_M_USBHC_READ,
+
+	/** Send data to device.
+	 * See explanation at usb_iface_funcs_t (OUT transaction).
+	 */
+	IPC_M_USBHC_WRITE,
 } usbhc_iface_funcs_t;
 
 /** Callback for outgoing transfer. */
-typedef void (*usbhc_iface_transfer_out_callback_t)(ddf_fun_t *,
-    int, void *);
+typedef void (*usbhc_iface_transfer_out_callback_t)(ddf_fun_t *, int, void *);
 
 /** Callback for incoming transfer. */
 typedef void (*usbhc_iface_transfer_in_callback_t)(ddf_fun_t *,
     int, size_t, void *);
-
-
-/** Out transfer processing function prototype. */
-typedef int (*usbhc_iface_transfer_out_t)(ddf_fun_t *, usb_target_t,
-    void *, size_t,
-    usbhc_iface_transfer_out_callback_t, void *);
-
-/** Setup transfer processing function prototype. @deprecated */
-typedef usbhc_iface_transfer_out_t usbhc_iface_transfer_setup_t;
-
-/** In transfer processing function prototype. */
-typedef int (*usbhc_iface_transfer_in_t)(ddf_fun_t *, usb_target_t,
-    void *, size_t,
-    usbhc_iface_transfer_in_callback_t, void *);
 
 /** USB host controller communication interface. */
@@ -223,17 +181,9 @@
 	    usb_direction_t);
 
-	usbhc_iface_transfer_out_t interrupt_out;
-	usbhc_iface_transfer_in_t interrupt_in;
+	int (*read)(ddf_fun_t *, usb_target_t, uint64_t, uint8_t *, size_t,
+	    usbhc_iface_transfer_in_callback_t, void *);
 
-	usbhc_iface_transfer_out_t bulk_out;
-	usbhc_iface_transfer_in_t bulk_in;
-
-	int (*control_write)(ddf_fun_t *, usb_target_t,
-	    void *, size_t, void *, size_t,
-	    usbhc_iface_transfer_out_callback_t, void *);
-
-	int (*control_read)(ddf_fun_t *, usb_target_t,
-	    void *, size_t, void *, size_t,
-	    usbhc_iface_transfer_in_callback_t, void *);
+	int (*write)(ddf_fun_t *, usb_target_t, uint64_t, const uint8_t *,
+	    size_t, usbhc_iface_transfer_out_callback_t, void *);
 } usbhc_iface_t;
 
Index: uspace/lib/usb/include/usb/hc.h
===================================================================
--- uspace/lib/usb/include/usb/hc.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usb/include/usb/hc.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -62,5 +62,5 @@
     devman_handle_t *);
 
-int usb_hc_get_address_by_handle(devman_handle_t);
+usb_address_t usb_hc_get_address_by_handle(devman_handle_t);
 
 int usb_hc_find(devman_handle_t, devman_handle_t *);
Index: uspace/lib/usb/include/usb/usb.h
===================================================================
--- uspace/lib/usb/include/usb/usb.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usb/include/usb/usb.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -36,4 +36,5 @@
 #define LIBUSB_USB_H_
 
+#include <bool.h>
 #include <sys/types.h>
 #include <byteorder.h>
@@ -105,5 +106,5 @@
  * Negative values could be used to indicate error.
  */
-typedef int usb_address_t;
+typedef int16_t usb_address_t;
 
 /** Default USB address. */
@@ -115,5 +116,5 @@
  * Negative values could be used to indicate error.
  */
-typedef int usb_endpoint_t;
+typedef int16_t usb_endpoint_t;
 
 /** Maximum endpoint number in USB 1.1.
@@ -125,8 +126,22 @@
  * Pair address + endpoint is identification of transaction recipient.
  */
-typedef struct {
-	usb_address_t address;
-	usb_endpoint_t endpoint;
+typedef union {
+	struct {
+		usb_address_t address;
+		usb_endpoint_t endpoint;
+	} __attribute__((packed));
+	uint32_t packed;
 } usb_target_t;
+
+/** Check USB target for allowed values (address and endpoint).
+ *
+ * @param target.
+ * @return True, if values are wihtin limits, false otherwise.
+ */
+static inline bool usb_target_is_valid(usb_target_t target)
+{
+	return !(target.endpoint > 15 || target.endpoint < 0
+	    || target.address >= USB11_ADDRESS_MAX || target.address < 0);
+}
 
 /** Compare USB targets (addresses and endpoints).
Index: uspace/lib/usbdev/src/pipesinit.c
===================================================================
--- uspace/lib/usbdev/src/pipesinit.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbdev/src/pipesinit.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -486,4 +486,6 @@
 		return EBADF;
 	
+	const usb_target_t target =
+	    {{ .address = pipe->wire->address, .endpoint = pipe->endpoint_no }};
 #define _PACK2(high, low) (((high) << 16) + (low))
 #define _PACK3(high, middle, low) (((((high) << 8) + (middle)) << 8) + (low))
@@ -491,6 +493,5 @@
 	async_exch_t *exch = async_exchange_begin(hc_connection->hc_sess);
 	int rc = async_req_4_0(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
-	    IPC_M_USBHC_REGISTER_ENDPOINT,
-	    _PACK2(pipe->wire->address, pipe->endpoint_no),
+	    IPC_M_USBHC_REGISTER_ENDPOINT, target.packed,
 	    _PACK3(speed, pipe->transfer_type, pipe->direction),
 	    _PACK2(pipe->max_packet_size, interval));
Index: uspace/lib/usbdev/src/pipesio.c
===================================================================
--- uspace/lib/usbdev/src/pipesio.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbdev/src/pipesio.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -65,20 +65,11 @@
     void *buffer, size_t size, size_t *size_transfered)
 {
-	/*
-	 * Get corresponding IPC method.
-	 * In future, replace with static array of mappings
-	 * transfer type -> method.
-	 */
-	usbhc_iface_funcs_t ipc_method;
-	switch (pipe->transfer_type) {
-		case USB_TRANSFER_INTERRUPT:
-			ipc_method = IPC_M_USBHC_INTERRUPT_IN;
-			break;
-		case USB_TRANSFER_BULK:
-			ipc_method = IPC_M_USBHC_BULK_IN;
-			break;
-		default:
-			return ENOTSUP;
-	}
+	/* Only interrupt and bulk transfers are supported */
+	if (pipe->transfer_type != USB_TRANSFER_INTERRUPT &&
+	    pipe->transfer_type != USB_TRANSFER_BULK)
+	    return ENOTSUP;
+
+	const usb_target_t target =
+	    {{ .address = pipe->wire->address, .endpoint = pipe->endpoint_no }};
 	
 	/* Ensure serialization over the phone. */
@@ -89,6 +80,6 @@
 	 * Make call identifying target USB device and type of transfer.
 	 */
-	aid_t opening_request = async_send_3(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
-	    ipc_method, pipe->wire->address, pipe->endpoint_no, NULL);
+	aid_t opening_request = async_send_2(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
+	    IPC_M_USBHC_READ, target.packed, NULL);
 	
 	if (opening_request == 0) {
@@ -213,20 +204,11 @@
     void *buffer, size_t size)
 {
-	/*
-	 * Get corresponding IPC method.
-	 * In future, replace with static array of mappings
-	 * transfer type -> method.
-	 */
-	usbhc_iface_funcs_t ipc_method;
-	switch (pipe->transfer_type) {
-		case USB_TRANSFER_INTERRUPT:
-			ipc_method = IPC_M_USBHC_INTERRUPT_OUT;
-			break;
-		case USB_TRANSFER_BULK:
-			ipc_method = IPC_M_USBHC_BULK_OUT;
-			break;
-		default:
-			return ENOTSUP;
-	}
+	/* Only interrupt and bulk transfers are supported */
+	if (pipe->transfer_type != USB_TRANSFER_INTERRUPT &&
+	    pipe->transfer_type != USB_TRANSFER_BULK)
+	    return ENOTSUP;
+
+	const usb_target_t target =
+	    {{ .address = pipe->wire->address, .endpoint = pipe->endpoint_no }};
 
 	/* Ensure serialization over the phone. */
@@ -238,5 +220,5 @@
 	 */
 	aid_t opening_request = async_send_3(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
-	    ipc_method, pipe->wire->address, pipe->endpoint_no, NULL);
+	    IPC_M_USBHC_WRITE, target.packed, size, NULL);
 	
 	if (opening_request == 0) {
@@ -352,28 +334,23 @@
 	pipe_start_transaction(pipe);
 
+	const usb_target_t target =
+	    {{ .address = pipe->wire->address, .endpoint = pipe->endpoint_no }};
+
+	assert(setup_buffer_size == 8);
+	uint64_t setup_packet;
+	memcpy(&setup_packet, setup_buffer, 8);
 	/*
 	 * Make call identifying target USB device and control transfer type.
 	 */
 	async_exch_t *exch = async_exchange_begin(pipe->hc_sess);
-	aid_t opening_request = async_send_3(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
-	    IPC_M_USBHC_CONTROL_READ, pipe->wire->address, pipe->endpoint_no,
-	    NULL);
-	
+	aid_t opening_request = async_send_4(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
+	    IPC_M_USBHC_READ, target.packed,
+	    (setup_packet & UINT32_MAX), (setup_packet >> 32), NULL);
+
 	if (opening_request == 0) {
 		async_exchange_end(exch);
 		return ENOMEM;
 	}
-	
-	/*
-	 * Send the setup packet.
-	 */
-	int rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
-	if (rc != EOK) {
-		async_exchange_end(exch);
-		pipe_end_transaction(pipe);
-		async_wait_for(opening_request, NULL);
-		return rc;
-	}
-	
+
 	/*
 	 * Retrieve the data.
@@ -498,11 +475,17 @@
 	pipe_start_transaction(pipe);
 
+	const usb_target_t target =
+	    {{ .address = pipe->wire->address, .endpoint = pipe->endpoint_no }};
+	assert(setup_buffer_size == 8);
+	uint64_t setup_packet;
+	memcpy(&setup_packet, setup_buffer, 8);
+
 	/*
 	 * Make call identifying target USB device and control transfer type.
 	 */
 	async_exch_t *exch = async_exchange_begin(pipe->hc_sess);
-	aid_t opening_request = async_send_4(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
-	    IPC_M_USBHC_CONTROL_WRITE, pipe->wire->address, pipe->endpoint_no,
-	    data_buffer_size, NULL);
+	aid_t opening_request = async_send_5(exch, DEV_IFACE_ID(USBHC_DEV_IFACE),
+	    IPC_M_USBHC_WRITE, target.packed, data_buffer_size,
+	    (setup_packet & UINT32_MAX), (setup_packet >> 32), NULL);
 	
 	if (opening_request == 0) {
@@ -511,21 +494,10 @@
 		return ENOMEM;
 	}
-	
-	/*
-	 * Send the setup packet.
-	 */
-	int rc = async_data_write_start(exch, setup_buffer, setup_buffer_size);
-	if (rc != EOK) {
-		async_exchange_end(exch);
-		pipe_end_transaction(pipe);
-		async_wait_for(opening_request, NULL);
-		return rc;
-	}
-	
+
 	/*
 	 * Send the data (if any).
 	 */
 	if (data_buffer_size > 0) {
-		rc = async_data_write_start(exch, data_buffer, data_buffer_size);
+		int rc = async_data_write_start(exch, data_buffer, data_buffer_size);
 		
 		/* All data sent, pipe can be released. */
Index: uspace/lib/usbhost/Makefile
===================================================================
--- uspace/lib/usbhost/Makefile	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbhost/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -32,11 +32,12 @@
 	-I$(LIBUSB_PREFIX)/include \
 	-I$(LIBDRV_PREFIX)/include \
-	-Iinclude
+	-Iinclude 
 
 SOURCES = \
-	src/batch.c \
-	src/device_keeper.c \
 	src/endpoint.c \
-	src/usb_endpoint_manager.c
+	src/iface.c \
+	src/usb_device_manager.c \
+	src/usb_endpoint_manager.c \
+	src/usb_transfer_batch.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/usbhost/include/usb/host/endpoint.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/endpoint.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbhost/include/usb/host/endpoint.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -54,4 +54,5 @@
 	fibril_condvar_t avail;
 	volatile bool active;
+	void (*destroy_hook)(struct endpoint *);
 	struct {
 		void *data;
@@ -68,5 +69,6 @@
 
 void endpoint_set_hc_data(endpoint_t *instance,
-    void *data, int (*toggle_get)(void *), void (*toggle_set)(void *, int));
+    void *data, void (*destroy_hook)(endpoint_t *),
+    int (*toggle_get)(void *), void (*toggle_set)(void *, int));
 
 void endpoint_clear_hc_data(endpoint_t *instance);
Index: uspace/lib/usbhost/include/usb/host/hcd.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/hcd.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/lib/usbhost/include/usb/host/hcd.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,87 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ *
+ */
+#ifndef LIBUSBHOST_HOST_HCD_H
+#define LIBUSBHOST_HOST_HCD_H
+
+#include <assert.h>
+#include <usb/host/usb_device_manager.h>
+#include <usb/host/usb_endpoint_manager.h>
+#include <usb/host/usb_transfer_batch.h>
+#include <usbhc_iface.h>
+
+typedef struct hcd hcd_t;
+
+struct hcd {
+	usb_device_manager_t dev_manager;
+	usb_endpoint_manager_t ep_manager;
+	void *private_data;
+
+	int (*schedule)(hcd_t *, usb_transfer_batch_t *);
+	int (*ep_add_hook)(hcd_t *, endpoint_t *);
+};
+/*----------------------------------------------------------------------------*/
+static inline int hcd_init(hcd_t *hcd, size_t bandwidth,
+    size_t (*bw_count)(usb_speed_t, usb_transfer_type_t, size_t, size_t))
+{
+	assert(hcd);
+	usb_device_manager_init(&hcd->dev_manager);
+	return usb_endpoint_manager_init(&hcd->ep_manager, bandwidth, bw_count);
+}
+/*----------------------------------------------------------------------------*/
+static inline void hcd_destroy(hcd_t *hcd)
+{
+	usb_endpoint_manager_destroy(&hcd->ep_manager);
+}
+/*----------------------------------------------------------------------------*/
+static inline void reset_ep_if_need(
+    hcd_t *hcd, usb_target_t target, const char* setup_data)
+{
+	assert(hcd);
+	usb_endpoint_manager_reset_if_need(
+	    &hcd->ep_manager, target, (const uint8_t *)setup_data);
+}
+/*----------------------------------------------------------------------------*/
+static inline hcd_t * fun_to_hcd(ddf_fun_t *fun)
+{
+	assert(fun);
+	return fun->driver_data;
+}
+/*----------------------------------------------------------------------------*/
+extern usbhc_iface_t hcd_iface;
+
+#endif
+/**
+ * @}
+ */
Index: uspace/lib/usbhost/include/usb/host/usb_device_manager.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_device_manager.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/lib/usbhost/include/usb/host/usb_device_manager.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ * Device manager structure and functions.
+ *
+ * Typical USB host controller needs to keep track of various settings for
+ * each device that is connected to it.
+ * State of toggle bit, device speed etc. etc.
+ * This structure shall simplify the management.
+ */
+#ifndef LIBUSBHOST_HOST_USB_DEVICE_MANAGER_H
+#define LIBUSBHOST_HOST_USB_DEVICE_MANAGER_H
+
+#include <adt/list.h>
+#include <devman.h>
+#include <fibril_synch.h>
+#include <usb/usb.h>
+#include <usb/host/endpoint.h>
+
+/** Number of USB address for array dimensions. */
+#define USB_ADDRESS_COUNT (USB11_ADDRESS_MAX + 1)
+
+/** Information about attached USB device. */
+struct usb_device_info {
+	usb_speed_t speed;
+	bool occupied;
+	devman_handle_t handle;
+};
+
+/** Host controller device manager.
+ * You shall not access members directly but only using functions below.
+ */
+typedef struct {
+	struct usb_device_info devices[USB_ADDRESS_COUNT];
+	fibril_mutex_t guard;
+	usb_address_t last_address;
+} usb_device_manager_t;
+
+void usb_device_manager_init(usb_device_manager_t *instance);
+
+usb_address_t usb_device_manager_get_free_address(
+    usb_device_manager_t *instance, usb_speed_t speed);
+
+void usb_device_manager_bind(usb_device_manager_t *instance,
+    usb_address_t address, devman_handle_t handle);
+
+void usb_device_manager_release(usb_device_manager_t *instance,
+    usb_address_t address);
+
+usb_address_t usb_device_manager_find(usb_device_manager_t *instance,
+    devman_handle_t handle);
+
+bool usb_device_manager_find_by_address(usb_device_manager_t *instance,
+    usb_address_t address, devman_handle_t *handle);
+
+usb_speed_t usb_device_manager_get_speed(usb_device_manager_t *instance,
+    usb_address_t address);
+#endif
+/**
+ * @}
+ */
Index: uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -38,5 +38,5 @@
  */
 #ifndef LIBUSBHOST_HOST_USB_ENDPOINT_MANAGER_H
-#define LIBUSBHOST_HOST_YSB_ENDPOINT_MANAGER_H
+#define LIBUSBHOST_HOST_USB_ENDPOINT_MANAGER_H
 
 #include <stdlib.h>
@@ -52,6 +52,6 @@
 	hash_table_t ep_table;
 	fibril_mutex_t guard;
-	fibril_condvar_t change;
 	size_t free_bw;
+	size_t (*bw_count)(usb_speed_t, usb_transfer_type_t, size_t, size_t);
 } usb_endpoint_manager_t;
 
@@ -60,5 +60,6 @@
 
 int usb_endpoint_manager_init(usb_endpoint_manager_t *instance,
-    size_t available_bandwidth);
+    size_t available_bandwidth,
+    size_t (*bw_count)(usb_speed_t, usb_transfer_type_t, size_t, size_t));
 
 void usb_endpoint_manager_destroy(usb_endpoint_manager_t *instance);
@@ -77,4 +78,5 @@
     usb_endpoint_manager_t *instance, usb_target_t target, const uint8_t *data);
 
+/** Wrapper combining allocation and insertion */
 static inline int usb_endpoint_manager_add_ep(usb_endpoint_manager_t *instance,
     usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
Index: uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,180 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ * USB transfer transaction structures.
+ */
+#ifndef LIBUSBHOST_HOST_USB_TRANSFER_BATCH_H
+#define LIBUSBHOST_HOST_USB_TRANSFER_BATCH_H
+
+#include <adt/list.h>
+
+#include <usbhc_iface.h>
+#include <usb/usb.h>
+#include <usb/host/endpoint.h>
+
+#define USB_SETUP_PACKET_SIZE 8
+
+typedef struct usb_transfer_batch usb_transfer_batch_t;
+/** Structure stores additional data needed for communication with EP */
+struct usb_transfer_batch {
+	/** Endpoint used for communication */
+	endpoint_t *ep;
+	/** Function called on completion (IN version) */
+	usbhc_iface_transfer_in_callback_t callback_in;
+	/** Function called on completion (OUT version) */
+	usbhc_iface_transfer_out_callback_t callback_out;
+	/** Argument to pass to the completion function */
+	void *arg;
+	/** Place for data to send/receive */
+	char *buffer;
+	/** Size of memory pointed to by buffer member */
+	size_t buffer_size;
+	/** Place to store SETUP data needed by control transfers */
+	char setup_buffer[USB_SETUP_PACKET_SIZE];
+	/** Used portion of setup_buffer member
+	 *
+	 * SETUP buffer must be 8 bytes for control transfers and is left
+	 * unused for all other transfers. Thus, this field is either 0 or 8.
+	 */
+	size_t setup_size;
+	/** Actually used portion of the buffer */
+	size_t transfered_size;
+	/** Indicates success/failure of the communication */
+	int error;
+	/** Host controller function, passed to callback function */
+	ddf_fun_t *fun;
+
+	/** Driver specific data */
+	void *private_data;
+	/** Callback to properly remove driver data during destruction */
+	void (*private_data_dtor)(void *p_data);
+};
+
+/** Printf formatting string for dumping usb_transfer_batch_t. */
+#define USB_TRANSFER_BATCH_FMT "[%d:%d %s %s-%s %zuB/%zu]"
+
+/** Printf arguments for dumping usb_transfer_batch_t.
+ * @param batch USB transfer batch to be dumped.
+ */
+#define USB_TRANSFER_BATCH_ARGS(batch) \
+	(batch).ep->address, (batch).ep->endpoint, \
+	usb_str_speed((batch).ep->speed), \
+	usb_str_transfer_type_short((batch).ep->transfer_type), \
+	usb_str_direction((batch).ep->direction), \
+	(batch).buffer_size, (batch).ep->max_packet_size
+
+
+usb_transfer_batch_t * usb_transfer_batch_get(
+    endpoint_t *ep,
+    char *buffer,
+    size_t buffer_size,
+    uint64_t setup_buffer,
+    usbhc_iface_transfer_in_callback_t func_in,
+    usbhc_iface_transfer_out_callback_t func_out,
+    void *arg,
+    ddf_fun_t *fun,
+    void *private_data,
+    void (*private_data_dtor)(void *p_data)
+);
+
+void usb_transfer_batch_finish(usb_transfer_batch_t *instance,
+    const void* data, size_t size);
+void usb_transfer_batch_call_in(usb_transfer_batch_t *instance);
+void usb_transfer_batch_call_out(usb_transfer_batch_t *instance);
+void usb_transfer_batch_dispose(usb_transfer_batch_t *instance);
+
+/** Helper function, calls callback and correctly destroys batch structure.
+ *
+ * @param[in] instance Batch structure to use.
+ */
+static inline void usb_transfer_batch_call_in_and_dispose(
+    usb_transfer_batch_t *instance)
+{
+	assert(instance);
+	usb_transfer_batch_call_in(instance);
+	usb_transfer_batch_dispose(instance);
+}
+/*----------------------------------------------------------------------------*/
+/** Helper function calls callback and correctly destroys batch structure.
+ *
+ * @param[in] instance Batch structure to use.
+ */
+static inline void usb_transfer_batch_call_out_and_dispose(
+    usb_transfer_batch_t *instance)
+{
+	assert(instance);
+	usb_transfer_batch_call_out(instance);
+	usb_transfer_batch_dispose(instance);
+}
+/*----------------------------------------------------------------------------*/
+/** Helper function, sets error value and finishes transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ * @param[in] data Data to copy to the output buffer.
+ * @param[in] size Size of @p data.
+ * @param[in] error Set batch status to this error value.
+ */
+static inline void usb_transfer_batch_finish_error(
+    usb_transfer_batch_t *instance, const void* data, size_t size, int error)
+{
+	assert(instance);
+	instance->error = error;
+	usb_transfer_batch_finish(instance, data, size);
+}
+/*----------------------------------------------------------------------------*/
+/** Helper function, determines batch direction absed on the present callbacks
+ * @param[in] instance Batch structure to use.
+ * @return USB_DIRECTION_IN, or USB_DIRECTION_OUT.
+ */
+static inline usb_direction_t usb_transfer_batch_direction(
+    const usb_transfer_batch_t *instance)
+{
+	assert(instance);
+	if (instance->callback_in) {
+		assert(instance->callback_out == NULL);
+		assert(instance->ep == NULL
+		    || instance->ep->transfer_type == USB_TRANSFER_CONTROL
+		    || instance->ep->direction == USB_DIRECTION_IN);
+		return USB_DIRECTION_IN;
+	}
+	if (instance->callback_out) {
+		assert(instance->callback_in == NULL);
+		assert(instance->ep == NULL
+		    || instance->ep->transfer_type == USB_TRANSFER_CONTROL
+		    || instance->ep->direction == USB_DIRECTION_OUT);
+		return USB_DIRECTION_OUT;
+	}
+	assert(false);
+}
+#endif
+/**
+ * @}
+ */
Index: uspace/lib/usbhost/src/endpoint.c
===================================================================
--- uspace/lib/usbhost/src/endpoint.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/usbhost/src/endpoint.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -53,4 +53,8 @@
 		instance->toggle = 0;
 		instance->active = false;
+		instance->destroy_hook = NULL;
+		instance->hc_data.data = NULL;
+		instance->hc_data.toggle_get = NULL;
+		instance->hc_data.toggle_set = NULL;
 		fibril_mutex_initialize(&instance->guard);
 		fibril_condvar_initialize(&instance->avail);
@@ -64,11 +68,17 @@
 	assert(instance);
 	assert(!instance->active);
+	if (instance->hc_data.data) {
+		assert(instance->destroy_hook);
+		instance->destroy_hook(instance);
+	}
 	free(instance);
 }
 /*----------------------------------------------------------------------------*/
 void endpoint_set_hc_data(endpoint_t *instance,
-    void *data, int (*toggle_get)(void *), void (*toggle_set)(void *, int))
+    void *data, void (*destroy_hook)(endpoint_t *),
+    int (*toggle_get)(void *), void (*toggle_set)(void *, int))
 {
 	assert(instance);
+	instance->destroy_hook = destroy_hook;
 	instance->hc_data.data = data;
 	instance->hc_data.toggle_get = toggle_get;
@@ -79,4 +89,5 @@
 {
 	assert(instance);
+	instance->destroy_hook = NULL;
 	instance->hc_data.data = NULL;
 	instance->hc_data.toggle_get = NULL;
